//
//  PgwApi.h
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Leftor d.o.o. All rights reserved.
//

#import <AFNetworking/AFNetworking.h>
#import "ShowOrderModel.h"
#import "ShowOrderResponse.h"
#import "Transaction.h"
#import "TransactionErrorDetailed.h"
#import "TransactionSuccess.h"
#import "ApiError.h"
#import "ApiErrors.h"
#import "BusinessError.h"

@interface PgwApi : NSObject

-(id)init:(NSString *) authToken
  isDebug:(bool) isDebug;

-(void) checkOrderId:(ShowOrderModel *)model
    success:(void (^)(ShowOrderResponse * model))successCallback
    failure:(void (^)(ApiError * error))failureCallback;

-(void) checkOrder:(ShowOrderModel *)model
             success:(void (^)(TransactionSuccess * model))successCallback
             failure:(void (^)(ApiError * error))failureCallback;

-(void) checkTransaction:(int) transactionId
             success:(void (^)(Transaction * model))successCallback
             failure:(void (^)(ApiError * error))failureCallback;

-(void) getError:(int) errorId
                 success:(void (^)(TransactionErrorDetailed * model))successCallback
                 failure:(void (^)(ApiError * error))failureCallback;

+(NSURLRequest *) payCvv:(NSString *) input;
+(NSURLRequest *) addCard:(NSString *) input;
@end
