//
//  ApiError.m
//  Pods
//
//  Created by Jasmin Suljic on 25/01/17.
//
//

#import <Foundation/Foundation.h>

#import "ApiError.h"


@implementation ApiError

-(id) init:(int)code error:(NSString *)error{
    return [self init:code error:error applicationError:false];
}

-(id) init:(int)code error:(NSString *)error applicationError:(BOOL)applicationError{
    _code = code;
    _error = error;
    _applicationError = applicationError;
    return [self init];
}

-(BOOL) isBusinessError{
    return !_applicationError;
}

-(BOOL) isDefiniteError{
    return self.definiteError;
}

+(ApiError *) fromJson: (NSDictionary *) jsonDict{
    
    if (!jsonDict) {
        return nil;
    } else {
        ApiError* error = [[ApiError alloc] init:[[jsonDict valueForKey:@"code"] intValue] error:[TransactionSuccess nilOrValue:[jsonDict valueForKey:@"error"]]];
        error.definiteError = [jsonDict objectForKey:@"definite_error"] ? [[jsonDict valueForKey:@"definite_error"] boolValue]: false;
        error.applicationError = [jsonDict objectForKey:@"library_error"] ? [[jsonDict valueForKey:@"library_error"] boolValue]: false;
        error.errorId = [jsonDict objectForKey:@"error_id"] ? [[jsonDict valueForKey:@"error_id"] intValue]: -1;
        return error;
    }
}

-(NSString *) description{
    return [NSString stringWithFormat:@"ApiError: {code: %d, error: %@, library_error: %d, definite_error: %d, error_id: %d}", _code, _error, _applicationError, _definiteError, _errorId ];
}


@end
