//
//  PayCvvModel.m
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "PayCvvModel.h"
#import "PayModel.h"
#import "InputResolver.h"

@implementation PayCvvModel

-(id) init:(NSString *)merchantId pmAlias:(NSString *)pmAlias client:(NSString *)client orderInfo:(NSString *)orderInfo orderNumber:(NSString *)orderNumber sign:(NSString *)sign amount:(NSString *)amount currency:(NSString *)currency clientSecret:(NSString *)clientSecret authToken:(NSString *)authToken{
    _merchantId = merchantId;
    _client = client;
    _orderInfo = orderInfo;
    _orderNumber = orderNumber;
    _sign = sign;
    _amount = amount;
    _currency = currency;
    _clientSecret = clientSecret;
    _authToken = authToken;
    _pmAlias = pmAlias;
    _digest = [PayModel sha1: [NSString stringWithFormat:@"%@%@%@%@%@%@%@%@",
                               _merchantId,
                               _pmAlias,
                               _authToken,
                               _orderNumber,
                               _sign,
                               _amount,
                               _currency,
                               _clientSecret
                               ]];
    return [self init];
}

-(NSString *) toInput{
    NSMutableDictionary *data = [[NSMutableDictionary alloc] init];
    
    [data setValue:_client forKey:@"client"];
    [data setValue:_merchantId forKey:@"merchant_id"];
    [data setValue:_orderInfo forKey:@"order_info"];
    [data setValue:_orderNumber forKey:@"order_number"];
    [data setValue:_sign forKey:@"sign"];
    [data setValue:_amount forKey:@"amount"];
    [data setValue:_currency forKey:@"currency"];
    [data setValue:_clientSecret forKey:@"client_secret"];
    [data setValue:_authToken forKey:@"auth_token"];
    [data setValue:_digest forKey:@"digest"];
    [data setValue:_pmAlias forKey:@"pm_alias"];
    
    return [InputResolver encode:data];
}

@end
