//
//  TransactionLifecycle.h
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Leftor d.o.o. All rights reserved.
//

#import "TransactionError.h"
#import "TransactionSuccess.h"
#import "ShowOrderResponse.h"
#import "TransactionErrorDetailed.h"
#import "ApiError.h"

@protocol TransactionLifecycleAdapterDelegate <NSObject>

-(void) showProgress;

-(void) hideProgress;

-(void) handleTransactionError: (ApiError *) error;

-(void) transactionSuccess: (TransactionSuccess *) success;

@optional
/**
 - This method is invoked after timeout. To stop further delegate calls stop web view from loading.
 */
-(void) stopWebViewLoad;

-(void) threeDsLoaded;

-(void) threeDsSubmitted;

-(void) webViewDidStartLoad:(UIWebView *)webView;

-(void) webViewDidFinishLoad:(UIWebView *)webView;
    
-(void) logTransactionInfo:(NSString *)loggingInfo;

@end
