//
//  TransactionSuccess.m
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "TransactionSuccess.h"
#import "InputResolver.h"

@implementation TransactionSuccess

-(id) init:(int)transactionId cardType:(NSString *)cardType pmAlias:(NSString *)pmAlias email:(NSString *)email fullName:(NSString *)fullName responseCode:(NSString *)responseCode approvalCode:(NSString *)approvalCode status:(NSString *)status merchantId:(NSString *)merchantId {
    _transactionId = transactionId;
    _cardType = cardType;
    _pmAlias = pmAlias;
    _email = email;
    _fullName = fullName;
    _responseCode = responseCode;
    _approvalCode = approvalCode;
    _status = status;
    _merchantId = merchantId;
    return [self init];
}

-(NSString *)description{
    return [NSString stringWithFormat:@"id: %d, cardType: %@, pmAlias: %@, email: %@, fullName: %@, responseCode: %@, approvalCode: %@, status: %@, merchantId: %@, amount: %0.2f, maskedPan: %@, responseMessage: %@",
            _transactionId,
            _cardType,
            _pmAlias,
            _email,
            _fullName,
            _responseCode,
            _approvalCode,
            _status,
            _merchantId,
            _amount,
            _maskedPan,
            _responseMessage];
}

+(TransactionSuccess *) fromString:(NSString *)input{
    return [TransactionSuccess fromJson:[InputResolver decode:input]];
    NSDictionary *data = [InputResolver decode:input];
}

+(TransactionSuccess *) fromJson:(NSDictionary *)data{
    TransactionSuccess *model = [[TransactionSuccess alloc] init:[[data valueForKey:@"id"] intValue]
                                                        cardType:[TransactionSuccess nilOrValue:[data valueForKey:@"card_type"]]
                                                         pmAlias:[TransactionSuccess nilOrValue:[data valueForKey:@"pm_alias"]]
                                                           email:[TransactionSuccess nilOrValue:[data valueForKey:@"ch_email"]]
                                                        fullName:[TransactionSuccess nilOrValue:[data valueForKey:@"ch_full_name"]]
                                                    responseCode:[TransactionSuccess nilOrValue:[data valueForKey:@"response_code"]]
                                                    approvalCode:[TransactionSuccess nilOrValue:[data valueForKey:@"approval_code"]]
                                                          status:[TransactionSuccess nilOrValue:[data valueForKey:@"status"]]
                                                      merchantId:[TransactionSuccess nilOrValue:[data valueForKey:@"merchant_id"]]
                                 ];
    model.maskedPan = [TransactionSuccess nilOrValue:[data valueForKey:@"masked_pan"]];
    model.responseMessage = [TransactionSuccess nilOrValue:[data valueForKey:@"response_message"]];
    model.amount = [[data valueForKey:@"amount" ] floatValue];
    
    return model;
}

// TODO: add this as extension
+(NSString *) nilOrValue: (NSString *) val{
    return val == [NSNull null] ? nil : val;
}

@end
