//
//  WebtehWebViewDelegate.m
//  pay
//
//  Created by Jasmin Suljic on 21/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WebtehWebViewDelegate.h"

@interface WebtehWebViewDelegate()
    @property(strong,nonatomic) RedirectResolver *redirectResolver;
    @end

@implementation WebtehWebViewDelegate
    
-(id) init: (RedirectResolver *) redirectResolver{
    self.redirectResolver = redirectResolver;
    return [self init];
}
    
- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType{
    [self.redirectResolver notifyDelegate:[self.redirectResolver resolve:request.URL.absoluteString] request:request.URL.absoluteString];
    return YES;
}
    
    -(void) logTransactionInfo:(NSString *)loggingInfo {
        if(self.redirectResolver.transactionLifecycleAdapter.delegate && [self.redirectResolver.transactionLifecycleAdapter.delegate respondsToSelector:@selector(logTransactionInfo:)]){
            [self.redirectResolver.transactionLifecycleAdapter.delegate logTransactionInfo:loggingInfo];
        }
    }
    
    
-(void) webViewDidStartLoad:(UIWebView *)webView {
    if(self.redirectResolver.transactionLifecycleAdapter.delegate && [self.redirectResolver.transactionLifecycleAdapter.delegate respondsToSelector:@selector(webViewDidStartLoad)]){
        
        [self logTransactionInfo:@"self.redirectResolver.transactionLifecycleAdapter.delegate#webViewDidStartLoad"];
        [self.redirectResolver.transactionLifecycleAdapter.delegate webViewDidStartLoad:webView];
    }
}
    
-(void) webViewDidFinishLoad:(UIWebView *)webView {
    if(self.redirectResolver.transactionLifecycleAdapter.delegate && [self.redirectResolver.transactionLifecycleAdapter.delegate respondsToSelector:@selector(webViewDidFinishLoad)]){
        [self logTransactionInfo:@"self.redirectResolver.transactionLifecycleAdapter.delegate#webViewDidFinishLoad"];
        [self.redirectResolver.transactionLifecycleAdapter.delegate webViewDidFinishLoad:webView];
    }
}
    
    
    @end
